/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the Campaign type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Campaign{}

// Campaign struct for Campaign
type Campaign struct {
	Id string `json:"id"`
	Type string `json:"type"`
	SubType *string `json:"sub_type,omitempty"`
	GroupId *string `json:"group_id,omitempty"`
	Name string `json:"name"`
	Status string `json:"status"`
	// Any of: Telegram, WhatsApp, Webchat, Facebook, Viber
	Messengers []string `json:"messengers,omitempty"`
	OrganizationId string `json:"organization_id"`
	// DEPRECATED
	TriggerConditions []CampaignTriggerConditionsInner `json:"trigger_conditions,omitempty"`
	ExecuteAt time.Time `json:"execute_at"`
	UpdatedAt time.Time `json:"updated_at"`
	CreatedAt time.Time `json:"created_at"`
	SendoutLimit int32 `json:"sendout_limit"`
	TargetAll bool `json:"target_all"`
	Recurring bool `json:"recurring"`
	RecurringConfig *CampaignRecurringConfig `json:"recurring_config,omitempty"`
	TargetChannels []CampaignTargetChannelsInner `json:"target_channels"`
	Strategy *CampaignStrategy `json:"strategy,omitempty"`
	BudgetLimitCents *int32 `json:"budget_limit_cents,omitempty"`
	Conditions []CampaignCondition `json:"conditions,omitempty"`
	Cooldown bool `json:"cooldown"`
	IncludeMarketingOptOuts *bool `json:"include_marketing_opt_outs,omitempty"`
	TargetType string `json:"target_type"`
	ConditionsDescription *string `json:"conditions_description,omitempty"`
	TargetContacts []CampaignTargetContactsInner `json:"target_contacts,omitempty"`
	TargetMode *string `json:"target_mode,omitempty"`
	TargetFilters map[string]interface{} `json:"target_filters,omitempty"`
	SendType *string `json:"send_type,omitempty"`
}

// NewCampaign instantiates a new Campaign object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaign(id string, type_ string, name string, status string, organizationId string, executeAt time.Time, updatedAt time.Time, createdAt time.Time, sendoutLimit int32, targetAll bool, recurring bool, targetChannels []CampaignTargetChannelsInner, cooldown bool, targetType string) *Campaign {
	this := Campaign{}
	this.Id = id
	this.Type = type_
	this.Name = name
	this.Status = status
	this.OrganizationId = organizationId
	this.ExecuteAt = executeAt
	this.UpdatedAt = updatedAt
	this.CreatedAt = createdAt
	this.SendoutLimit = sendoutLimit
	this.TargetAll = targetAll
	this.Recurring = recurring
	this.TargetChannels = targetChannels
	this.Cooldown = cooldown
	this.TargetType = targetType
	return &this
}

// NewCampaignWithDefaults instantiates a new Campaign object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignWithDefaults() *Campaign {
	this := Campaign{}
	return &this
}

// GetId returns the Id field value
func (o *Campaign) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Campaign) SetId(v string) {
	o.Id = v
}

// GetType returns the Type field value
func (o *Campaign) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *Campaign) SetType(v string) {
	o.Type = v
}

// GetSubType returns the SubType field value if set, zero value otherwise.
func (o *Campaign) GetSubType() string {
	if o == nil || IsNil(o.SubType) {
		var ret string
		return ret
	}
	return *o.SubType
}

// GetSubTypeOk returns a tuple with the SubType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetSubTypeOk() (*string, bool) {
	if o == nil || IsNil(o.SubType) {
		return nil, false
	}
	return o.SubType, true
}

// HasSubType returns a boolean if a field has been set.
func (o *Campaign) HasSubType() bool {
	if o != nil && !IsNil(o.SubType) {
		return true
	}

	return false
}

// SetSubType gets a reference to the given string and assigns it to the SubType field.
func (o *Campaign) SetSubType(v string) {
	o.SubType = &v
}

// GetGroupId returns the GroupId field value if set, zero value otherwise.
func (o *Campaign) GetGroupId() string {
	if o == nil || IsNil(o.GroupId) {
		var ret string
		return ret
	}
	return *o.GroupId
}

// GetGroupIdOk returns a tuple with the GroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.GroupId) {
		return nil, false
	}
	return o.GroupId, true
}

// HasGroupId returns a boolean if a field has been set.
func (o *Campaign) HasGroupId() bool {
	if o != nil && !IsNil(o.GroupId) {
		return true
	}

	return false
}

// SetGroupId gets a reference to the given string and assigns it to the GroupId field.
func (o *Campaign) SetGroupId(v string) {
	o.GroupId = &v
}

// GetName returns the Name field value
func (o *Campaign) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Campaign) SetName(v string) {
	o.Name = v
}

// GetStatus returns the Status field value
func (o *Campaign) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *Campaign) SetStatus(v string) {
	o.Status = v
}

// GetMessengers returns the Messengers field value if set, zero value otherwise.
func (o *Campaign) GetMessengers() []string {
	if o == nil || IsNil(o.Messengers) {
		var ret []string
		return ret
	}
	return o.Messengers
}

// GetMessengersOk returns a tuple with the Messengers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetMessengersOk() ([]string, bool) {
	if o == nil || IsNil(o.Messengers) {
		return nil, false
	}
	return o.Messengers, true
}

// HasMessengers returns a boolean if a field has been set.
func (o *Campaign) HasMessengers() bool {
	if o != nil && !IsNil(o.Messengers) {
		return true
	}

	return false
}

// SetMessengers gets a reference to the given []string and assigns it to the Messengers field.
func (o *Campaign) SetMessengers(v []string) {
	o.Messengers = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Campaign) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Campaign) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetTriggerConditions returns the TriggerConditions field value if set, zero value otherwise.
func (o *Campaign) GetTriggerConditions() []CampaignTriggerConditionsInner {
	if o == nil || IsNil(o.TriggerConditions) {
		var ret []CampaignTriggerConditionsInner
		return ret
	}
	return o.TriggerConditions
}

// GetTriggerConditionsOk returns a tuple with the TriggerConditions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetTriggerConditionsOk() ([]CampaignTriggerConditionsInner, bool) {
	if o == nil || IsNil(o.TriggerConditions) {
		return nil, false
	}
	return o.TriggerConditions, true
}

// HasTriggerConditions returns a boolean if a field has been set.
func (o *Campaign) HasTriggerConditions() bool {
	if o != nil && !IsNil(o.TriggerConditions) {
		return true
	}

	return false
}

// SetTriggerConditions gets a reference to the given []CampaignTriggerConditionsInner and assigns it to the TriggerConditions field.
func (o *Campaign) SetTriggerConditions(v []CampaignTriggerConditionsInner) {
	o.TriggerConditions = v
}

// GetExecuteAt returns the ExecuteAt field value
func (o *Campaign) GetExecuteAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.ExecuteAt
}

// GetExecuteAtOk returns a tuple with the ExecuteAt field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetExecuteAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ExecuteAt, true
}

// SetExecuteAt sets field value
func (o *Campaign) SetExecuteAt(v time.Time) {
	o.ExecuteAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *Campaign) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *Campaign) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Campaign) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Campaign) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetSendoutLimit returns the SendoutLimit field value
func (o *Campaign) GetSendoutLimit() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.SendoutLimit
}

// GetSendoutLimitOk returns a tuple with the SendoutLimit field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetSendoutLimitOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SendoutLimit, true
}

// SetSendoutLimit sets field value
func (o *Campaign) SetSendoutLimit(v int32) {
	o.SendoutLimit = v
}

// GetTargetAll returns the TargetAll field value
func (o *Campaign) GetTargetAll() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.TargetAll
}

// GetTargetAllOk returns a tuple with the TargetAll field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetTargetAllOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TargetAll, true
}

// SetTargetAll sets field value
func (o *Campaign) SetTargetAll(v bool) {
	o.TargetAll = v
}

// GetRecurring returns the Recurring field value
func (o *Campaign) GetRecurring() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Recurring
}

// GetRecurringOk returns a tuple with the Recurring field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetRecurringOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Recurring, true
}

// SetRecurring sets field value
func (o *Campaign) SetRecurring(v bool) {
	o.Recurring = v
}

// GetRecurringConfig returns the RecurringConfig field value if set, zero value otherwise.
func (o *Campaign) GetRecurringConfig() CampaignRecurringConfig {
	if o == nil || IsNil(o.RecurringConfig) {
		var ret CampaignRecurringConfig
		return ret
	}
	return *o.RecurringConfig
}

// GetRecurringConfigOk returns a tuple with the RecurringConfig field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetRecurringConfigOk() (*CampaignRecurringConfig, bool) {
	if o == nil || IsNil(o.RecurringConfig) {
		return nil, false
	}
	return o.RecurringConfig, true
}

// HasRecurringConfig returns a boolean if a field has been set.
func (o *Campaign) HasRecurringConfig() bool {
	if o != nil && !IsNil(o.RecurringConfig) {
		return true
	}

	return false
}

// SetRecurringConfig gets a reference to the given CampaignRecurringConfig and assigns it to the RecurringConfig field.
func (o *Campaign) SetRecurringConfig(v CampaignRecurringConfig) {
	o.RecurringConfig = &v
}

// GetTargetChannels returns the TargetChannels field value
func (o *Campaign) GetTargetChannels() []CampaignTargetChannelsInner {
	if o == nil {
		var ret []CampaignTargetChannelsInner
		return ret
	}

	return o.TargetChannels
}

// GetTargetChannelsOk returns a tuple with the TargetChannels field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetTargetChannelsOk() ([]CampaignTargetChannelsInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetChannels, true
}

// SetTargetChannels sets field value
func (o *Campaign) SetTargetChannels(v []CampaignTargetChannelsInner) {
	o.TargetChannels = v
}

// GetStrategy returns the Strategy field value if set, zero value otherwise.
func (o *Campaign) GetStrategy() CampaignStrategy {
	if o == nil || IsNil(o.Strategy) {
		var ret CampaignStrategy
		return ret
	}
	return *o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetStrategyOk() (*CampaignStrategy, bool) {
	if o == nil || IsNil(o.Strategy) {
		return nil, false
	}
	return o.Strategy, true
}

// HasStrategy returns a boolean if a field has been set.
func (o *Campaign) HasStrategy() bool {
	if o != nil && !IsNil(o.Strategy) {
		return true
	}

	return false
}

// SetStrategy gets a reference to the given CampaignStrategy and assigns it to the Strategy field.
func (o *Campaign) SetStrategy(v CampaignStrategy) {
	o.Strategy = &v
}

// GetBudgetLimitCents returns the BudgetLimitCents field value if set, zero value otherwise.
func (o *Campaign) GetBudgetLimitCents() int32 {
	if o == nil || IsNil(o.BudgetLimitCents) {
		var ret int32
		return ret
	}
	return *o.BudgetLimitCents
}

// GetBudgetLimitCentsOk returns a tuple with the BudgetLimitCents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetBudgetLimitCentsOk() (*int32, bool) {
	if o == nil || IsNil(o.BudgetLimitCents) {
		return nil, false
	}
	return o.BudgetLimitCents, true
}

// HasBudgetLimitCents returns a boolean if a field has been set.
func (o *Campaign) HasBudgetLimitCents() bool {
	if o != nil && !IsNil(o.BudgetLimitCents) {
		return true
	}

	return false
}

// SetBudgetLimitCents gets a reference to the given int32 and assigns it to the BudgetLimitCents field.
func (o *Campaign) SetBudgetLimitCents(v int32) {
	o.BudgetLimitCents = &v
}

// GetConditions returns the Conditions field value if set, zero value otherwise.
func (o *Campaign) GetConditions() []CampaignCondition {
	if o == nil || IsNil(o.Conditions) {
		var ret []CampaignCondition
		return ret
	}
	return o.Conditions
}

// GetConditionsOk returns a tuple with the Conditions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetConditionsOk() ([]CampaignCondition, bool) {
	if o == nil || IsNil(o.Conditions) {
		return nil, false
	}
	return o.Conditions, true
}

// HasConditions returns a boolean if a field has been set.
func (o *Campaign) HasConditions() bool {
	if o != nil && !IsNil(o.Conditions) {
		return true
	}

	return false
}

// SetConditions gets a reference to the given []CampaignCondition and assigns it to the Conditions field.
func (o *Campaign) SetConditions(v []CampaignCondition) {
	o.Conditions = v
}

// GetCooldown returns the Cooldown field value
func (o *Campaign) GetCooldown() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Cooldown
}

// GetCooldownOk returns a tuple with the Cooldown field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetCooldownOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Cooldown, true
}

// SetCooldown sets field value
func (o *Campaign) SetCooldown(v bool) {
	o.Cooldown = v
}

// GetIncludeMarketingOptOuts returns the IncludeMarketingOptOuts field value if set, zero value otherwise.
func (o *Campaign) GetIncludeMarketingOptOuts() bool {
	if o == nil || IsNil(o.IncludeMarketingOptOuts) {
		var ret bool
		return ret
	}
	return *o.IncludeMarketingOptOuts
}

// GetIncludeMarketingOptOutsOk returns a tuple with the IncludeMarketingOptOuts field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetIncludeMarketingOptOutsOk() (*bool, bool) {
	if o == nil || IsNil(o.IncludeMarketingOptOuts) {
		return nil, false
	}
	return o.IncludeMarketingOptOuts, true
}

// HasIncludeMarketingOptOuts returns a boolean if a field has been set.
func (o *Campaign) HasIncludeMarketingOptOuts() bool {
	if o != nil && !IsNil(o.IncludeMarketingOptOuts) {
		return true
	}

	return false
}

// SetIncludeMarketingOptOuts gets a reference to the given bool and assigns it to the IncludeMarketingOptOuts field.
func (o *Campaign) SetIncludeMarketingOptOuts(v bool) {
	o.IncludeMarketingOptOuts = &v
}

// GetTargetType returns the TargetType field value
func (o *Campaign) GetTargetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TargetType
}

// GetTargetTypeOk returns a tuple with the TargetType field value
// and a boolean to check if the value has been set.
func (o *Campaign) GetTargetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TargetType, true
}

// SetTargetType sets field value
func (o *Campaign) SetTargetType(v string) {
	o.TargetType = v
}

// GetConditionsDescription returns the ConditionsDescription field value if set, zero value otherwise.
func (o *Campaign) GetConditionsDescription() string {
	if o == nil || IsNil(o.ConditionsDescription) {
		var ret string
		return ret
	}
	return *o.ConditionsDescription
}

// GetConditionsDescriptionOk returns a tuple with the ConditionsDescription field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetConditionsDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.ConditionsDescription) {
		return nil, false
	}
	return o.ConditionsDescription, true
}

// HasConditionsDescription returns a boolean if a field has been set.
func (o *Campaign) HasConditionsDescription() bool {
	if o != nil && !IsNil(o.ConditionsDescription) {
		return true
	}

	return false
}

// SetConditionsDescription gets a reference to the given string and assigns it to the ConditionsDescription field.
func (o *Campaign) SetConditionsDescription(v string) {
	o.ConditionsDescription = &v
}

// GetTargetContacts returns the TargetContacts field value if set, zero value otherwise.
func (o *Campaign) GetTargetContacts() []CampaignTargetContactsInner {
	if o == nil || IsNil(o.TargetContacts) {
		var ret []CampaignTargetContactsInner
		return ret
	}
	return o.TargetContacts
}

// GetTargetContactsOk returns a tuple with the TargetContacts field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetTargetContactsOk() ([]CampaignTargetContactsInner, bool) {
	if o == nil || IsNil(o.TargetContacts) {
		return nil, false
	}
	return o.TargetContacts, true
}

// HasTargetContacts returns a boolean if a field has been set.
func (o *Campaign) HasTargetContacts() bool {
	if o != nil && !IsNil(o.TargetContacts) {
		return true
	}

	return false
}

// SetTargetContacts gets a reference to the given []CampaignTargetContactsInner and assigns it to the TargetContacts field.
func (o *Campaign) SetTargetContacts(v []CampaignTargetContactsInner) {
	o.TargetContacts = v
}

// GetTargetMode returns the TargetMode field value if set, zero value otherwise.
func (o *Campaign) GetTargetMode() string {
	if o == nil || IsNil(o.TargetMode) {
		var ret string
		return ret
	}
	return *o.TargetMode
}

// GetTargetModeOk returns a tuple with the TargetMode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetTargetModeOk() (*string, bool) {
	if o == nil || IsNil(o.TargetMode) {
		return nil, false
	}
	return o.TargetMode, true
}

// HasTargetMode returns a boolean if a field has been set.
func (o *Campaign) HasTargetMode() bool {
	if o != nil && !IsNil(o.TargetMode) {
		return true
	}

	return false
}

// SetTargetMode gets a reference to the given string and assigns it to the TargetMode field.
func (o *Campaign) SetTargetMode(v string) {
	o.TargetMode = &v
}

// GetTargetFilters returns the TargetFilters field value if set, zero value otherwise.
func (o *Campaign) GetTargetFilters() map[string]interface{} {
	if o == nil || IsNil(o.TargetFilters) {
		var ret map[string]interface{}
		return ret
	}
	return o.TargetFilters
}

// GetTargetFiltersOk returns a tuple with the TargetFilters field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetTargetFiltersOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.TargetFilters) {
		return map[string]interface{}{}, false
	}
	return o.TargetFilters, true
}

// HasTargetFilters returns a boolean if a field has been set.
func (o *Campaign) HasTargetFilters() bool {
	if o != nil && !IsNil(o.TargetFilters) {
		return true
	}

	return false
}

// SetTargetFilters gets a reference to the given map[string]interface{} and assigns it to the TargetFilters field.
func (o *Campaign) SetTargetFilters(v map[string]interface{}) {
	o.TargetFilters = v
}

// GetSendType returns the SendType field value if set, zero value otherwise.
func (o *Campaign) GetSendType() string {
	if o == nil || IsNil(o.SendType) {
		var ret string
		return ret
	}
	return *o.SendType
}

// GetSendTypeOk returns a tuple with the SendType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Campaign) GetSendTypeOk() (*string, bool) {
	if o == nil || IsNil(o.SendType) {
		return nil, false
	}
	return o.SendType, true
}

// HasSendType returns a boolean if a field has been set.
func (o *Campaign) HasSendType() bool {
	if o != nil && !IsNil(o.SendType) {
		return true
	}

	return false
}

// SetSendType gets a reference to the given string and assigns it to the SendType field.
func (o *Campaign) SetSendType(v string) {
	o.SendType = &v
}

func (o Campaign) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Campaign) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["type"] = o.Type
	if !IsNil(o.SubType) {
		toSerialize["sub_type"] = o.SubType
	}
	if !IsNil(o.GroupId) {
		toSerialize["group_id"] = o.GroupId
	}
	toSerialize["name"] = o.Name
	toSerialize["status"] = o.Status
	if !IsNil(o.Messengers) {
		toSerialize["messengers"] = o.Messengers
	}
	toSerialize["organization_id"] = o.OrganizationId
	if !IsNil(o.TriggerConditions) {
		toSerialize["trigger_conditions"] = o.TriggerConditions
	}
	toSerialize["execute_at"] = o.ExecuteAt
	toSerialize["updated_at"] = o.UpdatedAt
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["sendout_limit"] = o.SendoutLimit
	toSerialize["target_all"] = o.TargetAll
	toSerialize["recurring"] = o.Recurring
	if !IsNil(o.RecurringConfig) {
		toSerialize["recurring_config"] = o.RecurringConfig
	}
	toSerialize["target_channels"] = o.TargetChannels
	if !IsNil(o.Strategy) {
		toSerialize["strategy"] = o.Strategy
	}
	if !IsNil(o.BudgetLimitCents) {
		toSerialize["budget_limit_cents"] = o.BudgetLimitCents
	}
	if !IsNil(o.Conditions) {
		toSerialize["conditions"] = o.Conditions
	}
	toSerialize["cooldown"] = o.Cooldown
	if !IsNil(o.IncludeMarketingOptOuts) {
		toSerialize["include_marketing_opt_outs"] = o.IncludeMarketingOptOuts
	}
	toSerialize["target_type"] = o.TargetType
	if !IsNil(o.ConditionsDescription) {
		toSerialize["conditions_description"] = o.ConditionsDescription
	}
	if !IsNil(o.TargetContacts) {
		toSerialize["target_contacts"] = o.TargetContacts
	}
	if !IsNil(o.TargetMode) {
		toSerialize["target_mode"] = o.TargetMode
	}
	if !IsNil(o.TargetFilters) {
		toSerialize["target_filters"] = o.TargetFilters
	}
	if !IsNil(o.SendType) {
		toSerialize["send_type"] = o.SendType
	}
	return toSerialize, nil
}

type NullableCampaign struct {
	value *Campaign
	isSet bool
}

func (v NullableCampaign) Get() *Campaign {
	return v.value
}

func (v *NullableCampaign) Set(val *Campaign) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaign) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaign) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaign(val *Campaign) *NullableCampaign {
	return &NullableCampaign{value: val, isSet: true}
}

func (v NullableCampaign) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaign) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


